""" Package constants """

__author__ = "Vince Reuter"
__email__ = "vreuter@virginia.edu"


# Compute-related
DEFAULT_COMPUTE_RESOURCES_NAME = "default"
SAMPLE_NAME_COLNAME = "sample_name"
COMPUTE_CONSTANTS = ["DEFAULT_COMPUTE_RESOURCES_NAME", "SAMPLE_NAME_COLNAME"]

# Project-related
NAME_TABLE_ATTR = "sample_table"
DATA_SOURCES_SECTION = "data_sources"
DERIVATIONS_DECLARATION = "derived_attributes"
IMPLICATIONS_DECLARATION = "implied_attributes"
METADATA_KEY = "metadata"
OUTDIR_KEY = "output_dir"
SAMPLE_INDEPENDENT_PROJECT_SECTIONS = \
        [METADATA_KEY, DERIVATIONS_DECLARATION, IMPLICATIONS_DECLARATION, "trackhubs"]
SUBPROJECTS_SECTION = "subprojects"
PROJECT_CONSTANTS = [
    "DATA_SOURCES_SECTION", "DERIVATIONS_DECLARATION",
    "IMPLICATIONS_DECLARATION", "METADATA_KEY", "NAME_TABLE_ATTR", "OUTDIR_KEY",
    "SAMPLE_INDEPENDENT_PROJECT_SECTIONS", "SUBPROJECTS_SECTION"]

# Sample-related
ASSAY_KEY = "protocol"
DATA_SOURCE_COLNAME = "data_source"
SAMPLE_ANNOTATIONS_KEY = NAME_TABLE_ATTR
SAMPLE_SUBANNOTATIONS_KEY = "subsample_table"
SAMPLE_EXECUTION_TOGGLE = "toggle"
VALID_READ_TYPES = ["single", "paired"]
REQUIRED_INPUTS_ATTR_NAME = "required_inputs_attr"
ALL_INPUTS_ATTR_NAME = "all_inputs_attr"
SAMPLE_CONSTANTS = ["ALL_INPUTS_ATTR_NAME", "ASSAY_KEY", "DATA_SOURCE_COLNAME",
                    "REQUIRED_INPUTS_ATTR_NAME", "SAMPLE_ANNOTATIONS_KEY",
                    "SAMPLE_SUBANNOTATIONS_KEY", "SAMPLE_EXECUTION_TOGGLE",
                    "VALID_READ_TYPES"]

# Other
FLAGS = ["completed", "running", "failed", "waiting", "partial"]
GENERIC_PROTOCOL_KEY = "*"
OTHER_CONSTANTS = ["FLAGS", "GENERIC_PROTOCOL_KEY"]


__all__ = COMPUTE_CONSTANTS + PROJECT_CONSTANTS + \
          SAMPLE_CONSTANTS + OTHER_CONSTANTS
